# language: ru

Функционал: Приоритеты настроек
    Как разработчик
    Я хочу иметь возможность использовать различные настройки команды с правильным приоритетом
    Чтобы выполнять коллективную разработку проекта 1С с помощью удобных шаблонов
    приоритет настроек, от максимального до минимального:
    - командная строка
    - переменные окружения
    - json-файл настроек, заданный в --settings
    - env.json - файл настроек в корне проекта, если явно не указаны настройки через --settings
    внутри json-файлов следующие приоритеты, от максимального до минимального:
    - настройки секции по имени команды
    - настройки секции по имени "default"

Контекст:
    Дано Я сохраняю значение "" в переменную окружения "RUNNER_SRC"
    И Я очищаю параметры команды "oscript" в контексте

Сценарий: Подготовка ИБ

    Допустим я подготовил репозиторий и рабочий каталог проекта
    И Я копирую каталог "cf" из каталога "tests/fixtures" проекта в рабочий каталог

    И Я очищаю параметры команды "oscript" в контексте

Сценарий: Полная проверка
    Когда Я сохраняю значение "ПутьИзПеременныхОкружения" в переменную окружения "RUNNER_SRC"

    Когда Я создаю файл "add.json" с текстом
        """
        {
            "default": {
                "--new-version":"ВерсияИзФайла-Умолчание-Settings",
                "--src":"ПутьИзФайла-Умолчание-Settings"
            },
            "set-version": {
                "--new-version":"ВерсияИзФайла-Команда-Settings",
                "--src":"ПутьИзФайла-Команда-Settings"
            }
        }
        """
    Когда Я создаю файл "env.json" с текстом
        """
        {
            "default": {
                "--new-version":"ПользовательИзФайла-Умолчание",
                "--src":"ПутьИзФайла-Умолчание"
            },
            "set-version": {
                "--new-version":"ВерсияИзФайла-Команда",
                "--src":"ПутьИзФайла-Команда"
            }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --new-version ВерсияИзКоманднойСтроки --src ПутьИзКоманднойСтроки --language ru"
    
    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзКоманднойСтроки - ПутьИзКоманднойСтроки |

Сценарий: Настройки из переменных окружения приоритетнее файла настроек из --settings
    И Я сохраняю значение "ПутьИзПеременныхОкружения" в переменную окружения "RUNNER_SRC"
    Когда Я создаю файл "add.json" с текстом
        """
        {
            "set-version": {
                "--new-version":"ВерсияИзФайла-Команда-Settings",
                "--src":"ПутьИзФайла-Команда-Settings"
            }
        }
        """
    Когда Я создаю файл "env.json" с текстом
        """
        {
            "set-version": {
                "--new-version":"ВерсияИзФайла-Команда",
                "--src":"ПутьИзФайла-Команда"
            }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --settings add.json --new-version ВерсияИзКоманднойСтроки --language ru"

    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзКоманднойСтроки - ПутьИзПеременныхОкружения |

Сценарий: Настройки из переменных окружения приоритетнее файла настроек по умолчанию
    И Я сохраняю значение "ПутьИзПеременныхОкружения" в переменную окружения "RUNNER_SRC"
    Когда Я создаю файл "env.json" с текстом
        """
        {
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда",
            "--src":"ПутьИзФайла-Команда"
        }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --new-version ВерсияИзКоманднойСтроки --language ru"

    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзКоманднойСтроки - ПутьИзПеременныхОкружения |

Сценарий: Настройки в json-файле по ключу --settings приоритетнее файла настроек по умолчанию
    Когда Я создаю файл "add.json" с текстом
        """
        {
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда-Settings",
            "--src":"ПутьИзФайла-Команда-Settings"
        }
        }
        """
    Когда Я создаю файл "env.json" с текстом
        """
        {
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда",
            "--src":"ПутьИзФайла-Команда"
        }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version  --settings add.json --new-version ВерсияИзКоманднойСтроки --language ru"

    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзКоманднойСтроки - ПутьИзФайла-Команда-Settings |

Сценарий: Если задан ключ --settings, то файл настроек по умолчанию (env.json) не используется
    Когда Я создаю файл "add.json" с текстом
        """
        {
        "set-version": {
            "--src":"ПутьИзФайла-Команда-Settings"
        }
        }
        """
    Когда Я создаю файл "env.json" с текстом
        """
        {
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда"
        }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version  --settings add.json --language ru"
    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на  - ПутьИзФайла-Команда-Settings |

Сценарий: Настройки команды в файле настроек по ключу --settings приоритетнее настроек по умолчанию из ключа "default"
    

    Когда Я создаю файл "add.json" с текстом
        """
        {
        "default": {
            "--new-version":"ВерсияИзФайла-Умолчание-Settings",
            "--src":"ПутьИзФайла-Умолчание-Settings"
        },
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда-Settings"
        }
        }
        """
    Когда Я создаю файл "env.json" с текстом
        """
        {
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда",
            "--src":"ПутьИзФайла-Команда"
        }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version  --settings add.json --new-version ВерсияИзКоманднойСтроки --language ru"

    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзКоманднойСтроки - ПутьИзФайла-Умолчание-Settings |

Сценарий: Настройки из файла по умолчанию (env.json) дополняют нехватающие настройки
    Когда Я создаю файл "env.json" с текстом
        """
        {
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда",
            "--src":"ПутьИзФайла-Команда"
        }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --new-version ВерсияИзКоманднойСтроки --language ru"

    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзКоманднойСтроки - ПутьИзФайла-Команда |

Сценарий: Настройки команды из файла по умолчанию (env.json) приоритетнее настроек по умолчанию из ключа "default" в этом файле
    

    Когда Я создаю файл "env.json" с текстом
        """
        {
        "default": {
            "--new-version":"ПользовательИзФайла-Умолчание",
            "--src":"ПутьИзФайла-Умолчание"
        },
        "set-version": {
            "--new-version":"ВерсияИзФайла-Команда"
        }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --new-version ВерсияИзКоманднойСтроки --language ru"

    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзКоманднойСтроки - ПутьИзФайла-Умолчание |

Сценарий: Булевые настройки команды в блоке команды в файле приоритетнее, чем в секции "default"
    
    Дано Я пропускаю этот сценарий в Windows

    Когда Я создаю файл "env.json" с текстом
        """
        {
            "default": {
                "--new-version":"ВерсияИзФайла-Умолчание-Settings",
                "--src":"ПутьИзФайла-Умолчание-Settings",
                "--check-module": true
            },
            "set-version": {
                "--new-version":"ВерсияИзФайла-Команда-Settings",
                "--check-module": false
            }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --language ru"
    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации |

Сценарий: Булевые настройки команды в файле в блоке команды приоритетнее, чем в секции "default" - другой порядок

    Когда Я создаю файл "env.json" с текстом
        """
        {
            "default": {
                "--new-version":"ВерсияИзФайла-Умолчание-Settings",
                "--src":"ПутьИзФайла-Умолчание-Settings",
                "--check-module": false
            },
            "set-version": {
                "--new-version":"ВерсияИзФайла-Команда-Settings",
                "--check-module": true
            }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --language ru"
    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках модуля |       

Сценарий: Строковые представления булевых настроек приводятся корректно

    Когда Я создаю файл "env.json" с текстом
        """
        {
            "default": {
                "--new-version":"ВерсияИзФайла-Умолчание-Settings",
                "--src":"ПутьИзФайла-Умолчание-Settings",
                "--check-module": 0
            },
            "set-version": {
                "--new-version":"ВерсияИзФайла-Команда-Settings",
                "--check-module": "истина"
            }
        }
        """

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --language ru"
    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках модуля | 

Сценарий: В файле настроек значения корректно получаются из переменных окружения

    Когда Я создаю файл "env.json" с текстом
        """
        {
            "default": {
                "--new-version":"ВерсияИзФайла-Умолчание-Settings",
                "--src":"${TEST_SRC}"
            }
        }
        """
    И Я сохраняю значение "ПутьИзПеременныхОкружения" в переменную окружения "TEST_SRC"    

    Когда Я выполняю команду "oscript" с параметрами "<КаталогПроекта>/src/main.os set-version --language ru"
    Тогда Вывод команды "oscript" содержит
        | Изменяю версию в исходниках конфигурации 1С на ВерсияИзФайла-Умолчание-Settings - ПутьИзПеременныхОкружения |               
